/*
 * This file was generated by the MozButton SDK,
 * which is part of the Toolbar Buttons project.
 * You should not edit this file, but rather download
 * the project source and rerun the builder.
 */

const Cc = Components.classes;
const Ci = Components.interfaces;
const Cu = Components.utils;

var EXPORTED_SYMBOLS = ["loadButtons", "unloadButtons", "setupButtons", "shutdownButtons"];

try {
	Cu.import("resource:///modules/CustomizableUI.jsm");
} catch(e) {
	Cu.import("chrome://toolbar-buttons/content/customizable.jsm");
}

Cu.import('resource://gre/modules/Services.jsm');
Cu.import("resource://services-common/stringbundle.js");

try { Cu.import('resource://modules/CustomizableUI.jsm'); } catch(e) {}

var gShutDownFunctions = [];

var toolbar_buttons = {
	interfaces: {},
	// the important global objects used by the extension
	toolbar_button_loader: function(parent, child) {
		var object_name;
		for(object_name in child){
			if(object_name == 'interfaces') {
				toolbar_buttons.toolbar_button_loader(parent.interfaces, child.interfaces);
			} else {
				parent[object_name] = child[object_name];
			}
		}
	},
	registerCleanUpFunction: function(func) {
		gShutDownFunctions.push(func);
	}

};
var loader = Cc["@mozilla.org/moz/jssubscript-loader;1"].getService(Ci.mozIJSSubScriptLoader);
var gScope = this;
// the number at the end forces a reload of the properties file, since sometimes it it catched when we don't want
var buttonStrings = new StringBundle("chrome://toolbar-buttons/locale/button_labels.properties?time=" + Date.now().toString());

function setupButtons() {
	loader.loadSubScript("chrome://toolbar-buttons/content/button.js", gScope);
	loader.loadSubScript("chrome://toolbar-buttons/content/messenger.js", gScope);
	loader.loadSubScript("chrome://toolbar-buttons/content/compose.js", gScope);
		CustomizableUI.createWidget({
		id: 'send-with-no-save',
		label: buttonStrings.get('send-with-no-save.label'),
		tooltiptext: buttonStrings.get('send-with-no-save.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.SendWithNoSave(event);
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'help',
		label: buttonStrings.get('help.label'),
		tooltiptext: buttonStrings.get('help.tooltip'),
		onCommand: function(event) {
			var window = event.target.ownerDocument.defaultView;
			window.openSupportURL();
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'themes',
		label: buttonStrings.get('themes.label'),
		tooltiptext: buttonStrings.get('themes.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.OpenAddonsMgr(event, 'themes', 'addons://list/theme');
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'minimize-window',
		label: buttonStrings.get('minimize-window.label'),
		tooltiptext: buttonStrings.get('minimize-window.tooltip'),
		onCommand: function(event) {
			var window = event.target.ownerDocument.defaultView;
			window.minimize();
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'toggle-proxy',
		type: 'custom',
		label: buttonStrings.get('toggle-proxy.label'),
		tooltiptext: buttonStrings.get('toggle-proxy.tooltip'),
		onCreated: function(aNode){
			var document = aNode.ownerDocument;
			toolbar_buttons.loadPrefWatcher(document, "network.proxy.type", "toggle-proxy");
		},
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'toggle-proxy';
			toolbarbutton_0.setAttribute("type", "menu-button");
			toolbarbutton_0.setAttribute('label', buttonStrings.get('toggle-proxy.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('toggle-proxy.tooltip'));
			toolbarbutton_0.addEventListener('command', function(event) {
				toolbar_buttons.toggleTheProxy();
			}, false);
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			var menupopup_1 = document.createElement('menupopup');
			menupopup_1.addEventListener('click', function(event) {
				event.stopPropagation();
			}, false);
			menupopup_1.addEventListener('command', function(event) {
				toolbar_buttons.setProxyValue(event); event.stopPropagation();
			}, false);
			menupopup_1.addEventListener('popupshowing', function(event) {
				var aThis = event.target;
			toolbar_buttons.setProxyMenuItem(event, aThis);
			}, false);
			var menuitem_2 = document.createElement('menuitem');
			menuitem_2.setAttribute("type", "radio");
			menuitem_2.setAttribute('label', buttonStrings.get('toggle.proxy.direct'));
			menuitem_2.setAttribute("name", "toggle-proxy-settings");
			menuitem_2.setAttribute("value", "0");
			menupopup_1.appendChild(menuitem_2);
			var menuitem_3 = document.createElement('menuitem');
			menuitem_3.setAttribute("type", "radio");
			menuitem_3.setAttribute('label', buttonStrings.get('toggle.proxy.manual'));
			menuitem_3.setAttribute("name", "toggle-proxy-settings");
			menuitem_3.setAttribute("value", "1");
			menupopup_1.appendChild(menuitem_3);
			var menuitem_4 = document.createElement('menuitem');
			menuitem_4.setAttribute("type", "radio");
			menuitem_4.setAttribute('label', buttonStrings.get('toggle.proxy.auto.configuration'));
			menuitem_4.setAttribute("name", "toggle-proxy-settings");
			menuitem_4.setAttribute("value", "2");
			menupopup_1.appendChild(menuitem_4);
			var menuitem_5 = document.createElement('menuitem');
			menuitem_5.setAttribute("type", "radio");
			menuitem_5.setAttribute('label', buttonStrings.get('toggle.proxy.auto.detect'));
			menuitem_5.setAttribute("name", "toggle-proxy-settings");
			menuitem_5.setAttribute("value", "4");
			menupopup_1.appendChild(menuitem_5);
			var menuitem_6 = document.createElement('menuitem');
			menuitem_6.setAttribute("type", "radio");
			menuitem_6.setAttribute('label', buttonStrings.get('toggle.proxy.system'));
			menuitem_6.setAttribute("name", "toggle-proxy-settings");
			menuitem_6.setAttribute("value", "5");
			menupopup_1.appendChild(menuitem_6);
			toolbarbutton_0.appendChild(menupopup_1);
			return toolbarbutton_0;
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'find-prev',
		type: 'custom',
		label: buttonStrings.get('find-prev.label'),
		tooltiptext: buttonStrings.get('find-prev.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'find-prev';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('find-prev.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('find-prev.tooltip'));
			toolbarbutton_0.setAttribute("command", "cmd_findPrev");
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			return toolbarbutton_0;
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-edit-menu',
		label: buttonStrings.get('tb-edit-menu.label'),
		tooltiptext: buttonStrings.get('tb-edit-menu.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.showAMenu(event, 'menu_Edit', 'edit-menu');
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-about-about',
		type: 'custom',
		label: buttonStrings.get('tb-about-about.label'),
		tooltiptext: buttonStrings.get('tb-about-about.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'tb-about-about';
			toolbarbutton_0.setAttribute("type", "menu");
			toolbarbutton_0.setAttribute('label', buttonStrings.get('tb-about-about.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('tb-about-about.tooltip'));
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			var menupopup_1 = document.createElement('menupopup');
			menupopup_1.addEventListener('command', function(event) {
				event.stopPropagation();
			}, false);
			menupopup_1.addEventListener('popupshowing', function(event) {
				var aThis = event.target;
			toolbar_buttons.aboutAboutMenu(aThis);
			}, false);
			toolbarbutton_0.appendChild(menupopup_1);
			return toolbarbutton_0;
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'redo',
		type: 'custom',
		label: buttonStrings.get('redo.label'),
		tooltiptext: buttonStrings.get('redo.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'redo';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('redo.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('redo.tooltip'));
			toolbarbutton_0.setAttribute("command", "cmd_redo");
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			toolbarbutton_0.setAttribute("key", "key_redo");
			return toolbarbutton_0;
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'find',
		label: buttonStrings.get('find.label'),
		tooltiptext: buttonStrings.get('find.tooltip'),
		onCommand: function(event) {
			var window = event.target.ownerDocument.defaultView;
			window.goDoCommand('cmd_find');
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'saveas',
		type: 'custom',
		label: buttonStrings.get('saveas.label'),
		tooltiptext: buttonStrings.get('saveas.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'saveas';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('saveas.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('saveas.tooltip'));
			toolbarbutton_0.setAttribute("command", "cmd_saveDefault");
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			return toolbarbutton_0;
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'delete-button',
		type: 'custom',
		label: buttonStrings.get('delete.label'),
		tooltiptext: buttonStrings.get('delete.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'delete-button';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('delete.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('delete.tooltip'));
			toolbarbutton_0.setAttribute("command", "cmd_delete");
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			toolbarbutton_0.setAttribute("key", "key_delete");
			return toolbarbutton_0;
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'about-plugins',
		label: buttonStrings.get('about-plugins.label'),
		tooltiptext: buttonStrings.get('about-plugins.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.openPageInTab('about:plugins', event);
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-toggle-menu-bar',
		label: buttonStrings.get('tb-toggle-menu-bar.label'),
		tooltiptext: buttonStrings.get('tb-toggle-menu-bar.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.toggleToolbar(event, 'compose-toolbar-menubar2');
		},
		onCreated: function(aNode) {
			var document = aNode.ownerDocument;
			toolbar_buttons.loadToggleToolbar(document, "tb-toggle-menu-bar", "compose-toolbar-menubar2");
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'customize-toolbar',
		type: 'custom',
		label: buttonStrings.get('customize-toolbar.label'),
		tooltiptext: buttonStrings.get('customize-toolbar.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'customize-toolbar';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('customize-toolbar.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('customize-toolbar.tooltip'));
			toolbarbutton_0.setAttribute("command", "cmd_CustomizeComposeToolbar");
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			return toolbarbutton_0;
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'toolbar-menu',
		type: 'custom',
		label: buttonStrings.get('toolbar-menu.label'),
		tooltiptext: buttonStrings.get('toolbar-menu.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'toolbar-menu';
			toolbarbutton_0.setAttribute("type", "menu");
			toolbarbutton_0.setAttribute('label', buttonStrings.get('toolbar-menu.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('toolbar-menu.tooltip'));
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			toolbarbutton_0.addEventListener('popupshowing', function(event) {
				var window = event.target.ownerDocument.defaultView;
			window.onViewToolbarsPopupShowing(event, 'compose-toolbox');
			}, false);
			var menupopup_1 = document.createElement('menupopup');
			menupopup_1.id = 'toolbar-popup';
			menupopup_1.addEventListener('command', function(event) {
				event.stopPropagation();
			}, false);
			toolbarbutton_0.appendChild(menupopup_1);
			return toolbarbutton_0;
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'find-again',
		type: 'custom',
		label: buttonStrings.get('find-again.label'),
		tooltiptext: buttonStrings.get('find-again.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'find-again';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('find-again.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('find-again.tooltip'));
			toolbarbutton_0.setAttribute("command", "cmd_findNext");
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			return toolbarbutton_0;
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'installaddons',
		label: buttonStrings.get('installaddons.label'),
		tooltiptext: buttonStrings.get('installaddons.tooltip'),
		onClick: function(event) {
			toolbar_buttons.viewAddonsExceptions(event);
		},
		onCommand: function(event) {
			toolbar_buttons.installAddons(event);
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'reload-proxy',
		label: buttonStrings.get('reload-proxy.label'),
		tooltiptext: buttonStrings.get('reload-proxy.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.reloadPAC();
		},
		onCreated: function(aNode) {
			var document = aNode.ownerDocument;
			toolbar_buttons.loadPrefWatcher(document, "network.proxy.type", null, toolbar_buttons.setProxyButtonState);
toolbar_buttons.loadPrefWatcher(document, "network.proxy.autoconfig_url", null, toolbar_buttons.setProxyButtonState);
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'import',
		label: buttonStrings.get('import.label'),
		tooltiptext: buttonStrings.get('import.tooltip'),
		onCommand: function(event) {
			var window = event.target.ownerDocument.defaultView;
			window.toImport();
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'profile-folder',
		label: buttonStrings.get('profile-folder.label'),
		tooltiptext: buttonStrings.get('profile-folder.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.profileFolder();
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'select-all',
		label: buttonStrings.get('select-all.label'),
		tooltiptext: buttonStrings.get('select-all.tooltip'),
		onCommand: function(event) {
			var window = event.target.ownerDocument.defaultView;
			window.window.goDoCommand('cmd_selectAll');
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'pagesetup',
		label: buttonStrings.get('pagesetup.label'),
		tooltiptext: buttonStrings.get('pagesetup.tooltip'),
		onCommand: function(event) {
			var window = event.target.ownerDocument.defaultView;
			window.goDoCommand('cmd_printSetup');
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'search-addresses',
		label: buttonStrings.get('search-addresses.label'),
		tooltiptext: buttonStrings.get('search-addresses.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.MsgSearchAddresses(event);
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-file-menu',
		label: buttonStrings.get('tb-file-menu.label'),
		tooltiptext: buttonStrings.get('tb-file-menu.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.showAMenu(event, 'menu_File', 'file-menu');
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'plainpaste',
		type: 'custom',
		label: buttonStrings.get('plainpaste.label'),
		tooltiptext: buttonStrings.get('plainpaste.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'plainpaste';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('plainpaste.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('plainpaste.tooltip'));
			toolbarbutton_0.setAttribute("command", "cmd_pasteNoFormatting");
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			return toolbarbutton_0;
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'accountwizard',
		label: buttonStrings.get('accountwizard.label'),
		tooltiptext: buttonStrings.get('accountwizard.tooltip'),
		onCommand: function(event) {
			var window = event.target.ownerDocument.defaultView;
			window.MsgAccountWizard();
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'about-config',
		label: buttonStrings.get('about-config.label'),
		tooltiptext: buttonStrings.get('about-config.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.openPageInTab('about:config', event);
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-all-menus',
		type: 'custom',
		label: buttonStrings.get('tb-all-menus.label'),
		tooltiptext: buttonStrings.get('tb-all-menus.tooltip'),
		onCreated: function(aNode){
			var document = aNode.ownerDocument;
			toolbar_buttons.allMenusStartUp(document);
		},
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'tb-all-menus';
			toolbarbutton_0.setAttribute("type", "menu");
			toolbarbutton_0.setAttribute('label', buttonStrings.get('tb-all-menus.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('tb-all-menus.tooltip'));
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			var menupopup_1 = document.createElement('menupopup');
			menupopup_1.id = 'tb-all-menus-popup';
			menupopup_1.addEventListener('command', function(event) {
				event.stopPropagation();
			}, false);
			menupopup_1.addEventListener('popupshowing', function(event) {
				var aThis = event.target;
			toolbar_buttons.loadAllMenusMenu(aThis, event);
			}, false);
			menupopup_1.addEventListener('popuphidden', function(event) {
				var aThis = event.target;
			toolbar_buttons.allMenusReturnPopups(aThis, event);
			}, false);
			toolbarbutton_0.appendChild(menupopup_1);
			return toolbarbutton_0;
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'undo',
		label: buttonStrings.get('undo.label'),
		tooltiptext: buttonStrings.get('undo.tooltip'),
		onCommand: function(event) {
			var window = event.target.ownerDocument.defaultView;
			try { window.CommandUpdate_UndoRedo(); } catch(e) {} window.goDoCommand('cmd_undo');
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'return-receipt',
		type: 'custom',
		label: buttonStrings.get('return-receipt.label'),
		tooltiptext: buttonStrings.get('return-receipt.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'return-receipt';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('return-receipt.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('return-receipt.tooltip'));
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			toolbarbutton_0.setAttribute("observes", "returnReceiptMenu");
			return toolbarbutton_0;
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'preferences',
		type: 'custom',
		label: buttonStrings.get('preferences.label'),
		tooltiptext: buttonStrings.get('preferences.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'preferences';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('preferences.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('preferences.tooltip'));
			toolbarbutton_0.setAttribute("command", "menu_preferences");
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			return toolbarbutton_0;
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'restart-app',
		label: buttonStrings.get('restart-app.label'),
		tooltiptext: buttonStrings.get('restart-app.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.restartMozilla();
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'about-application',
		label: buttonStrings.get('about-application.label'),
		tooltiptext: buttonStrings.get('about-application.tooltip') + ' ' + Cc['@mozilla.org/xre/app-info;1'].createInstance(Ci.nsIXULAppInfo).name,
		onCommand: function(event) {
			var window = event.target.ownerDocument.defaultView;
			window.openAboutDialog();
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-cookie-manager',
		label: buttonStrings.get('tb-cookie-manager.label'),
		tooltiptext: buttonStrings.get('tb-cookie-manager.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.openMessengerWindowOrTab('chrome://messenger/content/preferences/cookies.xul', event);
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'exit',
		label: buttonStrings.get('exit.label'),
		tooltiptext: buttonStrings.get('exit.tooltip'),
		onCommand: function(event) {
			goQuitApplication()
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'accountmanager',
		label: buttonStrings.get('accountmanager.label'),
		tooltiptext: buttonStrings.get('accountmanager.tooltip'),
		onCommand: function(event) {
			var window = event.target.ownerDocument.defaultView;
			window.MsgAccountManager(null);
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-saved-passwords',
		label: buttonStrings.get('tb-saved-passwords.label'),
		tooltiptext: buttonStrings.get('tb-saved-passwords.tooltip'),
		onClick: function(event) {
			toolbar_buttons.openMessengerWindowOrTab('chrome://passwordmgr/content/passwordManager.xul', event);
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-tools-menu',
		label: buttonStrings.get('tb-tools-menu.label'),
		tooltiptext: buttonStrings.get('tb-tools-menu.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.showAMenu(event, 'tasksMenu', 'menu_Tools', 'tools-menu');
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'extensions',
		label: buttonStrings.get('extensions.label'),
		tooltiptext: buttonStrings.get('extensions.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.OpenAddonsMgr(event, 'extensions', 'addons://list/extension');
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'statusbar-toggle',
		label: buttonStrings.get('statusbar-toggle.label'),
		tooltiptext: buttonStrings.get('statusbar-toggle.tooltip'),
		onCommand: function(event) {
			var window = event.target.ownerDocument.defaultView;
			window.goToggleToolbar('status-bar', 'menu_showTaskbar');
		},
		onCreated: function(aNode) {
			var document = aNode.ownerDocument;
			toolbar_buttons.loadToggleToolbar(document, "statusbar-toggle", "status-bar");
toolbar_buttons.loadToggleToolbar(document, "statusbar-toggle", "addon-bar");
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'javaScriptConsole',
		label: buttonStrings.get('javaScriptConsole.label'),
		tooltiptext: buttonStrings.get('javaScriptConsole.tooltip'),
		onCommand: function(event) {
			var window = event.target.ownerDocument.defaultView;
			window.toJavaScriptConsole();
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'addons',
		type: 'custom',
		label: buttonStrings.get('addons.label'),
		tooltiptext: buttonStrings.get('addons.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'addons';
			toolbarbutton_0.setAttribute("type", "menu-button");
			toolbarbutton_0.setAttribute('label', buttonStrings.get('addons.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('addons.tooltip'));
			toolbarbutton_0.addEventListener('command', function(event) {
				var window = event.target.ownerDocument.defaultView;
			window.openAddonsMgr();
			}, false);
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			toolbarbutton_0.setAttribute("key", "key_openAddons");
			var menupopup_1 = document.createElement('menupopup');
			menupopup_1.addEventListener('click', function(event) {
				event.stopPropagation();
			}, false);
			menupopup_1.addEventListener('command', function(event) {
				event.stopPropagation();
			}, false);
			var menuitem_2 = document.createElement('menuitem');
			menuitem_2.id = 'tb-addons-extensions';
			menuitem_2.setAttribute('label', buttonStrings.get('extensions.label'));
			menuitem_2.addEventListener('command', function(event) {
				toolbar_buttons.OpenAddonsMgr(event, 'extensions', 'addons://list/extension');
			}, false);
			menupopup_1.appendChild(menuitem_2);
			var menuitem_3 = document.createElement('menuitem');
			menuitem_3.id = 'tb-addons-themes';
			menuitem_3.setAttribute('label', buttonStrings.get('themes.label'));
			menuitem_3.addEventListener('command', function(event) {
				toolbar_buttons.OpenAddonsMgr(event, 'themes', 'addons://list/theme');
			}, false);
			menupopup_1.appendChild(menuitem_3);
			var menuseparator_4 = document.createElement('menuseparator');
			menupopup_1.appendChild(menuseparator_4);
			var menuitem_5 = document.createElement('menuitem');
			menuitem_5.id = 'tb-addons-install';
			menuitem_5.setAttribute('label', buttonStrings.get('installaddons.label'));
			menuitem_5.addEventListener('command', function(event) {
				toolbar_buttons.installAddons(event);
			}, false);
			menupopup_1.appendChild(menuitem_5);
			toolbarbutton_0.appendChild(menupopup_1);
			return toolbarbutton_0;
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-view-menu',
		label: buttonStrings.get('tb-view-menu.label'),
		tooltiptext: buttonStrings.get('tb-view-menu.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.showAMenu(event, 'menu_View', 'view-menu');
		},
		toolbox: 'compose-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'dictionary-list',
		type: 'custom',
		label: buttonStrings.get('dictionary-list.label'),
		tooltiptext: buttonStrings.get('dictionary-list.tooltip'),
		onCreated: function(aNode){
			var document = aNode.ownerDocument;
			// copied off the context menu
		},
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'dictionary-list';
			toolbarbutton_0.setAttribute("type", "menu");
			toolbarbutton_0.setAttribute('label', buttonStrings.get('dictionary-list.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('dictionary-list.tooltip'));
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			var menupopup_1 = document.createElement('menupopup');
			menupopup_1.addEventListener('command', function(event) {
				event.stopPropagation();
			}, false);
			menupopup_1.addEventListener('popupshowing', function(event) {
				var aThis = event.target;
			toolbar_buttons.addDictionaryList(aThis);
			}, false);
			toolbarbutton_0.appendChild(menupopup_1);
			return toolbarbutton_0;
		},
		toolbox: 'compose-toolbox'
	});
}

function loadButtons(window) {
	var document = window.document;
	var toolbox = document.getElementById('compose-toolbox');
	if(!toolbox) {
		return;
	}
	
	registerToolbars(window, document, []);
	
	
	toolbar_buttons.loadToggleToolbar(document, "statusbar-toggle", "status-bar");
toolbar_buttons.loadToggleToolbar(document, "statusbar-toggle", "addon-bar");
	// copied off the context menu
	toolbar_buttons.loadDocumentColors(document);
	toolbar_buttons.loadToggleToolbar(document, "tb-toggle-menu-bar", "compose-toolbar-menubar2");
	toolbar_buttons.loadPrefWatcher(document, "mailnews.display.html_as", "html-mode");
	toolbar_buttons.loadPrefWatcher(document, "network.proxy.type", "toggle-proxy");
	toolbar_buttons.loadPrefWatcher(document, "network.proxy.type", null, toolbar_buttons.setProxyButtonState);
toolbar_buttons.loadPrefWatcher(document, "network.proxy.autoconfig_url", null, toolbar_buttons.setProxyButtonState);
	toolbar_buttons.loadPrefWatcher(document, "browser.display.use_document_fonts", "use-document-fonts");
	toolbar_buttons.allMenusStartUp(document);
}

function createToolbar(doc, toolbox, attributes, name) {
	var special = ["id", "class", "defaultset", "currentset"];
	var toolbar = doc.createElement('toolbar');
	for(var attr in attributes) {
		if(special.indexOf(attr) == -1) {
			toolbar.setAttribute(attr, attributes[attr]);
		}
	}
	toolbar.setAttribute('toolbarname', name);
	if(attributes.id) {
		toolbar.id = attributes.id;
	}
	if(attributes.class) {
		toolbar.className = attributes.class;
	}
	doc.getElementById(toolbox).appendChild(toolbar);
	// put after appending to stop Thunderbird/SeaMonkey loading the buttons
	// which messes with our CustomizableUI
	if(attributes.defaultset) {
		toolbar.setAttribute('defaultset', attributes['defaultset']);
	}
	if(attributes.currentset) {
		toolbar.setAttribute('currentset', attributes['currentset']);
	}
}

var gButtonIds = ["send-with-no-save", "help", "themes", "minimize-window", "toggle-proxy", "find-prev", "tb-edit-menu", "tb-about-about", "redo", "find", "saveas", "delete-button", "about-plugins", "tb-toggle-menu-bar", "customize-toolbar", "toolbar-menu", "find-again", "installaddons", "reload-proxy", "import", "profile-folder", "select-all", "pagesetup", "search-addresses", "tb-file-menu", "plainpaste", "accountwizard", "about-config", "tb-all-menus", "undo", "return-receipt", "preferences", "restart-app", "about-application", "tb-cookie-manager", "exit", "accountmanager", "tb-saved-passwords", "tb-tools-menu", "extensions", "statusbar-toggle", "javaScriptConsole", "addons", "tb-view-menu", "dictionary-list"];

function unloadButtons(window) {
	var document = window.document;
	var toolbarIds = [];
	var uiIds = [];

	for(var t = 0; t < toolbarIds.length; t++) {
		var toolbar = document.getElementById(toolbarIds[t]);
		if(toolbar) {
			CustomizableUI.unregisterArea(toolbarIds[t], false);
			toolbar.parentNode.removeChild(toolbar);
		}
	}
	for(var i = 0; i < gButtonIds.length; i++) {
		var buttonId = gButtonIds[i];
		var key = document.getElementById(buttonId + '-key');
		if(key) {
			key.parentNode.removeChild(key);
		}
		var menuitem = document.getElementById(buttonId + '-menu-item');
		if(menuitem) {
			menuitem.parentNode.removeChild(menuitem);
		}
	}
	var menu = document.getElementById('toolbar-buttons-menu');
	if(menu && !menu.firstChild.firstChild) {
		menu.parentNode.removeChild(menu);
	}
	for(var i = 0; i < uiIds.length; i++) {
		var node = document.getElementById(uiIds[i]);
		while(node) {
			node.parentNode.removeChild(node);
			node = document.getElementById(uiIds[i]);
		}
	}
	for(var i = 0; i < gShutDownFunctions.length; i++) {
		try {
			gShutDownFunctions[i]();
		} catch(e) {}
	}
}

function shutdownButtons() {
	log(gButtonIds);
	for(var i = 0; i < gButtonIds.length; i++) {
		CustomizableUI.destroyWidget(gButtonIds[i]);
	}
}

function registerToolbars(window, document, toolbar_ids) {
	for(var i in toolbar_ids) {
		observeToolbar(window, document, toolbar_ids[i]);
		CustomizableUI.registerArea(toolbar_ids[i], {
			type: CustomizableUI.TYPE_TOOLBAR,
			defaultPlacements: [],
			defaultCollapsed: false
		}, true);
	}
}

function observeToolbar(window, document, toolbar_id) {
	var prefs = Cc['@mozilla.org/preferences-service;1'].getService(Ci.nsIPrefService)
			.getBranch("extension.tbutton." + 'toolbar_status.' + toolbar_id + '.');
	var toolbar = document.getElementById(toolbar_id);
	var observer = function(mutations) {
		mutations.forEach(function(mutation) {
			if(mutation.attributeName && (CustomizableUI.shim || mutation.attributeName != 'currentset')) {
				prefs.setCharPref(mutation.attributeName, toolbar.getAttribute(mutation.attributeName));
			}
		});
	}
	var mutationObserver = new window.MutationObserver(observer);
	var attrList = prefs.getChildList('', {});
	for(var i in attrList) {
		toolbar.setAttribute(attrList[i], prefs.getCharPref(attrList[i]));
	}
	mutationObserver.observe(toolbar, { attributes: true, subtree: false });
}

function log(e) {
	Cc["@mozilla.org/consoleservice;1"].getService(Ci.nsIConsoleService).logStringMessage(e);
}