/*
 * This file was generated by the MozButton SDK,
 * which is part of the Toolbar Buttons project.
 * You should not edit this file, but rather download
 * the project source and rerun the builder.
 */

const Cc = Components.classes;
const Ci = Components.interfaces;
const Cu = Components.utils;

var EXPORTED_SYMBOLS = ["loadButtons", "unloadButtons", "setupButtons", "shutdownButtons"];

try {
	Cu.import("resource:///modules/CustomizableUI.jsm");
} catch(e) {
	Cu.import("chrome://toolbar-buttons/content/customizable.jsm");
}

Cu.import('resource://gre/modules/Services.jsm');
Cu.import("resource://services-common/stringbundle.js");



var gShutDownFunctions = [];

var toolbar_buttons = {
	interfaces: {},
	// the important global objects used by the extension
	toolbar_button_loader: function(parent, child) {
		var object_name;
		for(object_name in child){
			if(object_name == 'interfaces') {
				toolbar_buttons.toolbar_button_loader(parent.interfaces, child.interfaces);
			} else {
				parent[object_name] = child[object_name];
			}
		}
	},
	registerCleanUpFunction: function(func) {
		gShutDownFunctions.push(func);
	}

};
var loader = Cc["@mozilla.org/moz/jssubscript-loader;1"].getService(Ci.mozIJSSubScriptLoader);
var gScope = this;
// the number at the end forces a reload of the properties file, since sometimes it it catched when we don't want
var buttonStrings = new StringBundle("chrome://toolbar-buttons/locale/button_labels.properties?time=" + Date.now().toString());

function setupButtons() {
	loader.loadSubScript("chrome://toolbar-buttons/content/button.js", gScope);
	loader.loadSubScript("chrome://toolbar-buttons/content/calendar.js", gScope);
		CustomizableUI.createWidget({
		id: 'themes',
		label: buttonStrings.get('themes.label'),
		tooltiptext: buttonStrings.get('themes.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.OpenAddonsMgr(event, 'themes', 'addons://list/theme');
		},
		toolbox: 'calendar-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'minimize-window',
		label: buttonStrings.get('minimize-window.label'),
		tooltiptext: buttonStrings.get('minimize-window.tooltip'),
		onCommand: function(event) {
			var window = event.target.ownerDocument.defaultView;
			window.minimize();
		},
		toolbox: 'calendar-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'toggle-proxy',
		type: 'custom',
		label: buttonStrings.get('toggle-proxy.label'),
		tooltiptext: buttonStrings.get('toggle-proxy.tooltip'),
		onCreated: function(aNode){
			var document = aNode.ownerDocument;
			toolbar_buttons.loadPrefWatcher(document, "network.proxy.type", "toggle-proxy");
		},
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'toggle-proxy';
			toolbarbutton_0.setAttribute("type", "menu-button");
			toolbarbutton_0.setAttribute('label', buttonStrings.get('toggle-proxy.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('toggle-proxy.tooltip'));
			toolbarbutton_0.addEventListener('command', function(event) {
				toolbar_buttons.toggleTheProxy();
			}, false);
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			var menupopup_1 = document.createElement('menupopup');
			menupopup_1.addEventListener('click', function(event) {
				event.stopPropagation();
			}, false);
			menupopup_1.addEventListener('command', function(event) {
				toolbar_buttons.setProxyValue(event); event.stopPropagation();
			}, false);
			menupopup_1.addEventListener('popupshowing', function(event) {
				var aThis = event.target;
			toolbar_buttons.setProxyMenuItem(event, aThis);
			}, false);
			var menuitem_2 = document.createElement('menuitem');
			menuitem_2.setAttribute("type", "radio");
			menuitem_2.setAttribute('label', buttonStrings.get('toggle.proxy.direct'));
			menuitem_2.setAttribute("name", "toggle-proxy-settings");
			menuitem_2.setAttribute("value", "0");
			menupopup_1.appendChild(menuitem_2);
			var menuitem_3 = document.createElement('menuitem');
			menuitem_3.setAttribute("type", "radio");
			menuitem_3.setAttribute('label', buttonStrings.get('toggle.proxy.manual'));
			menuitem_3.setAttribute("name", "toggle-proxy-settings");
			menuitem_3.setAttribute("value", "1");
			menupopup_1.appendChild(menuitem_3);
			var menuitem_4 = document.createElement('menuitem');
			menuitem_4.setAttribute("type", "radio");
			menuitem_4.setAttribute('label', buttonStrings.get('toggle.proxy.auto.configuration'));
			menuitem_4.setAttribute("name", "toggle-proxy-settings");
			menuitem_4.setAttribute("value", "2");
			menupopup_1.appendChild(menuitem_4);
			var menuitem_5 = document.createElement('menuitem');
			menuitem_5.setAttribute("type", "radio");
			menuitem_5.setAttribute('label', buttonStrings.get('toggle.proxy.auto.detect'));
			menuitem_5.setAttribute("name", "toggle-proxy-settings");
			menuitem_5.setAttribute("value", "4");
			menupopup_1.appendChild(menuitem_5);
			var menuitem_6 = document.createElement('menuitem');
			menuitem_6.setAttribute("type", "radio");
			menuitem_6.setAttribute('label', buttonStrings.get('toggle.proxy.system'));
			menuitem_6.setAttribute("name", "toggle-proxy-settings");
			menuitem_6.setAttribute("value", "5");
			menupopup_1.appendChild(menuitem_6);
			toolbarbutton_0.appendChild(menupopup_1);
			return toolbarbutton_0;
		},
		toolbox: 'calendar-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-edit-menu',
		label: buttonStrings.get('tb-edit-menu.label'),
		tooltiptext: buttonStrings.get('tb-edit-menu.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.showAMenu(event, 'menu_Edit', 'edit-menu');
		},
		toolbox: 'calendar-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'delete-event',
		type: 'custom',
		label: buttonStrings.get('delete-event.label'),
		tooltiptext: buttonStrings.get('delete-event.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'delete-event';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('delete-event.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('delete-event.tooltip'));
			toolbarbutton_0.addEventListener('command', function(event) {
				toolbar_buttons.deleteEvent(event);
			}, false);
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			toolbarbutton_0.setAttribute("observes", "calendar_delete_event_command");
			return toolbarbutton_0;
		},
		toolbox: 'calendar-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-about-about',
		type: 'custom',
		label: buttonStrings.get('tb-about-about.label'),
		tooltiptext: buttonStrings.get('tb-about-about.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'tb-about-about';
			toolbarbutton_0.setAttribute("type", "menu");
			toolbarbutton_0.setAttribute('label', buttonStrings.get('tb-about-about.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('tb-about-about.tooltip'));
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			var menupopup_1 = document.createElement('menupopup');
			menupopup_1.addEventListener('command', function(event) {
				event.stopPropagation();
			}, false);
			menupopup_1.addEventListener('popupshowing', function(event) {
				var aThis = event.target;
			toolbar_buttons.aboutAboutMenu(aThis);
			}, false);
			toolbarbutton_0.appendChild(menupopup_1);
			return toolbarbutton_0;
		},
		toolbox: 'calendar-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'delete-tasks',
		type: 'custom',
		label: buttonStrings.get('delete-tasks.label'),
		tooltiptext: buttonStrings.get('delete-tasks.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'delete-tasks';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('delete-tasks.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('delete-tasks.tooltip'));
			toolbarbutton_0.addEventListener('command', function(event) {
				toolbar_buttons.deleteTasks(event);
			}, false);
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			toolbarbutton_0.setAttribute("observes", "calendar_delete_todo_command");
			return toolbarbutton_0;
		},
		toolbox: 'calendar-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tasks-toggle',
		type: 'custom',
		label: buttonStrings.get('tasks-toggle.label'),
		tooltiptext: buttonStrings.get('tasks-toggle.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'tasks-toggle';
			toolbarbutton_0.setAttribute("type", "checkbox");
			toolbarbutton_0.setAttribute('label', buttonStrings.get('tasks-toggle.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('tasks-toggle.tooltip'));
			toolbarbutton_0.addEventListener('command', function(event) {
				toolbar_buttons.toggleTasks(event);
			}, false);
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			toolbarbutton_0.setAttribute("persist", "checked");
			return toolbarbutton_0;
		},
		toolbox: 'calendar-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'about-plugins',
		label: buttonStrings.get('about-plugins.label'),
		tooltiptext: buttonStrings.get('about-plugins.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.openPageInTab('about:plugins', event);
		},
		toolbox: 'calendar-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'installaddons',
		label: buttonStrings.get('installaddons.label'),
		tooltiptext: buttonStrings.get('installaddons.tooltip'),
		onClick: function(event) {
			toolbar_buttons.viewAddonsExceptions(event);
		},
		onCommand: function(event) {
			toolbar_buttons.installAddons(event);
		},
		toolbox: 'calendar-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'reload-proxy',
		label: buttonStrings.get('reload-proxy.label'),
		tooltiptext: buttonStrings.get('reload-proxy.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.reloadPAC();
		},
		onCreated: function(aNode) {
			var document = aNode.ownerDocument;
			toolbar_buttons.loadPrefWatcher(document, "network.proxy.type", null, toolbar_buttons.setProxyButtonState);
toolbar_buttons.loadPrefWatcher(document, "network.proxy.autoconfig_url", null, toolbar_buttons.setProxyButtonState);
		},
		toolbox: 'calendar-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'profile-folder',
		label: buttonStrings.get('profile-folder.label'),
		tooltiptext: buttonStrings.get('profile-folder.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.profileFolder();
		},
		toolbox: 'calendar-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-file-menu',
		label: buttonStrings.get('tb-file-menu.label'),
		tooltiptext: buttonStrings.get('tb-file-menu.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.showAMenu(event, 'menu_File', 'file-menu');
		},
		toolbox: 'calendar-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-new-event',
		type: 'custom',
		label: buttonStrings.get('tb-new-event.label'),
		tooltiptext: buttonStrings.get('tb-new-event.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'tb-new-event';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('tb-new-event.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('tb-new-event.tooltip'));
			toolbarbutton_0.setAttribute("command", "calendar_new_event_command");
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			toolbarbutton_0.setAttribute("observes", "calendar_new_event_command");
			return toolbarbutton_0;
		},
		toolbox: 'calendar-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'about-config',
		label: buttonStrings.get('about-config.label'),
		tooltiptext: buttonStrings.get('about-config.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.openPageInTab('about:config', event);
		},
		toolbox: 'calendar-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-new-task',
		type: 'custom',
		label: buttonStrings.get('tb-new-task.label'),
		tooltiptext: buttonStrings.get('tb-new-task.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'tb-new-task';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('tb-new-task.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('tb-new-task.tooltip'));
			toolbarbutton_0.setAttribute("command", "calendar_new_todo_command");
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			toolbarbutton_0.setAttribute("observes", "calendar_new_todo_command");
			return toolbarbutton_0;
		},
		toolbox: 'calendar-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-all-menus',
		type: 'custom',
		label: buttonStrings.get('tb-all-menus.label'),
		tooltiptext: buttonStrings.get('tb-all-menus.tooltip'),
		onCreated: function(aNode){
			var document = aNode.ownerDocument;
			toolbar_buttons.allMenusStartUp(document);
		},
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'tb-all-menus';
			toolbarbutton_0.setAttribute("type", "menu");
			toolbarbutton_0.setAttribute('label', buttonStrings.get('tb-all-menus.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('tb-all-menus.tooltip'));
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("chromeclass-toolbar-additional");
			var menupopup_1 = document.createElement('menupopup');
			menupopup_1.id = 'tb-all-menus-popup';
			menupopup_1.addEventListener('command', function(event) {
				event.stopPropagation();
			}, false);
			menupopup_1.addEventListener('popupshowing', function(event) {
				var aThis = event.target;
			toolbar_buttons.loadAllMenusMenu(aThis, event);
			}, false);
			menupopup_1.addEventListener('popuphidden', function(event) {
				var aThis = event.target;
			toolbar_buttons.allMenusReturnPopups(aThis, event);
			}, false);
			toolbarbutton_0.appendChild(menupopup_1);
			return toolbarbutton_0;
		},
		toolbox: 'calendar-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'restart-app',
		label: buttonStrings.get('restart-app.label'),
		tooltiptext: buttonStrings.get('restart-app.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.restartMozilla();
		},
		toolbox: 'calendar-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'about-application',
		label: buttonStrings.get('about-application.label'),
		tooltiptext: buttonStrings.get('about-application.tooltip') + ' ' + Cc['@mozilla.org/xre/app-info;1'].createInstance(Ci.nsIXULAppInfo).name,
		onCommand: function(event) {
			var window = event.target.ownerDocument.defaultView;
			window.openAboutDialog();
		},
		toolbox: 'calendar-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tasks-in-view',
		label: buttonStrings.get('tasks-in-view.label'),
		tooltiptext: buttonStrings.get('tasks-in-view.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.tasksInView(event);
		},
		onCreated: function(aNode) {
			var document = aNode.ownerDocument;
			tasksInView: function(event {
	var win = event.target.ownerDocument.defaultView;
	try {
		win.changeDisplayToDoInViewCheckbox();
	} catch(e) {
		win.toggleTasksInView();
	}
}
		},
		toolbox: 'calendar-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-tools-menu',
		label: buttonStrings.get('tb-tools-menu.label'),
		tooltiptext: buttonStrings.get('tb-tools-menu.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.showAMenu(event, 'tasksMenu', 'menu_Tools', 'tools-menu');
		},
		toolbox: 'calendar-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'extensions',
		label: buttonStrings.get('extensions.label'),
		tooltiptext: buttonStrings.get('extensions.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.OpenAddonsMgr(event, 'extensions', 'addons://list/extension');
		},
		toolbox: 'calendar-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'tb-view-menu',
		label: buttonStrings.get('tb-view-menu.label'),
		tooltiptext: buttonStrings.get('tb-view-menu.tooltip'),
		onCommand: function(event) {
			toolbar_buttons.showAMenu(event, 'menu_View', 'view-menu');
		},
		toolbox: 'calendar-toolbox'
	});
}

function loadButtons(window) {
	var document = window.document;
	var toolbox = document.getElementById('calendar-toolbox');
	if(!toolbox) {
		return;
	}
	
	registerToolbars(window, document, []);
	
	
	toolbar_buttons.loadToggleToolbar(document, "statusbar-toggle", "status-bar");
toolbar_buttons.loadToggleToolbar(document, "statusbar-toggle", "addon-bar");
	// copied off the context menu
	toolbar_buttons.loadDocumentColors(document);
	toolbar_buttons.loadPrefWatcher(document, "network.proxy.type", "toggle-proxy");
	tasksInView: function(event {
	var win = event.target.ownerDocument.defaultView;
	try {
		win.changeDisplayToDoInViewCheckbox();
	} catch(e) {
		win.toggleTasksInView();
	}
}
	toolbar_buttons.loadPrefWatcher(document, "network.proxy.type", null, toolbar_buttons.setProxyButtonState);
toolbar_buttons.loadPrefWatcher(document, "network.proxy.autoconfig_url", null, toolbar_buttons.setProxyButtonState);
	toolbar_buttons.loadPrefWatcher(document, "browser.display.use_document_fonts", "use-document-fonts");
	toolbar_buttons.allMenusStartUp(document);
	toolbar_buttons.loadToggleToolbar(document, "toggle-toolbar", "calendar-bar");
}

function createToolbar(doc, toolbox, attributes, name) {
	var special = ["id", "class", "defaultset", "currentset"];
	var toolbar = doc.createElement('toolbar');
	for(var attr in attributes) {
		if(special.indexOf(attr) == -1) {
			toolbar.setAttribute(attr, attributes[attr]);
		}
	}
	toolbar.setAttribute('toolbarname', name);
	if(attributes.id) {
		toolbar.id = attributes.id;
	}
	if(attributes.class) {
		toolbar.className = attributes.class;
	}
	doc.getElementById(toolbox).appendChild(toolbar);
	// put after appending to stop Thunderbird/SeaMonkey loading the buttons
	// which messes with our CustomizableUI
	if(attributes.defaultset) {
		toolbar.setAttribute('defaultset', attributes['defaultset']);
	}
	if(attributes.currentset) {
		toolbar.setAttribute('currentset', attributes['currentset']);
	}
}

var gButtonIds = ["themes", "minimize-window", "toggle-proxy", "tb-edit-menu", "delete-event", "tb-about-about", "delete-tasks", "tasks-toggle", "about-plugins", "installaddons", "reload-proxy", "profile-folder", "tb-file-menu", "tb-new-event", "about-config", "tb-new-task", "tb-all-menus", "restart-app", "about-application", "tasks-in-view", "tb-tools-menu", "extensions", "tb-view-menu"];

function unloadButtons(window) {
	var document = window.document;
	var toolbarIds = [];
	var uiIds = [];

	for(var t = 0; t < toolbarIds.length; t++) {
		var toolbar = document.getElementById(toolbarIds[t]);
		if(toolbar) {
			CustomizableUI.unregisterArea(toolbarIds[t], false);
			toolbar.parentNode.removeChild(toolbar);
		}
	}
	for(var i = 0; i < gButtonIds.length; i++) {
		var buttonId = gButtonIds[i];
		var key = document.getElementById(buttonId + '-key');
		if(key) {
			key.parentNode.removeChild(key);
		}
		var menuitem = document.getElementById(buttonId + '-menu-item');
		if(menuitem) {
			menuitem.parentNode.removeChild(menuitem);
		}
	}
	var menu = document.getElementById('toolbar-buttons-menu');
	if(menu && !menu.firstChild.firstChild) {
		menu.parentNode.removeChild(menu);
	}
	for(var i = 0; i < uiIds.length; i++) {
		var node = document.getElementById(uiIds[i]);
		while(node) {
			node.parentNode.removeChild(node);
			node = document.getElementById(uiIds[i]);
		}
	}
	for(var i = 0; i < gShutDownFunctions.length; i++) {
		try {
			gShutDownFunctions[i]();
		} catch(e) {}
	}
}

function shutdownButtons() {
	log(gButtonIds);
	for(var i = 0; i < gButtonIds.length; i++) {
		CustomizableUI.destroyWidget(gButtonIds[i]);
	}
}

function registerToolbars(window, document, toolbar_ids) {
	for(var i in toolbar_ids) {
		observeToolbar(window, document, toolbar_ids[i]);
		CustomizableUI.registerArea(toolbar_ids[i], {
			type: CustomizableUI.TYPE_TOOLBAR,
			defaultPlacements: [],
			defaultCollapsed: false
		}, true);
	}
}

function observeToolbar(window, document, toolbar_id) {
	var prefs = Cc['@mozilla.org/preferences-service;1'].getService(Ci.nsIPrefService)
			.getBranch("extension.tbutton." + 'toolbar_status.' + toolbar_id + '.');
	var toolbar = document.getElementById(toolbar_id);
	var observer = function(mutations) {
		mutations.forEach(function(mutation) {
			if(mutation.attributeName && (CustomizableUI.shim || mutation.attributeName != 'currentset')) {
				prefs.setCharPref(mutation.attributeName, toolbar.getAttribute(mutation.attributeName));
			}
		});
	}
	var mutationObserver = new window.MutationObserver(observer);
	var attrList = prefs.getChildList('', {});
	for(var i in attrList) {
		toolbar.setAttribute(attrList[i], prefs.getCharPref(attrList[i]));
	}
	mutationObserver.observe(toolbar, { attributes: true, subtree: false });
}

function log(e) {
	Cc["@mozilla.org/consoleservice;1"].getService(Ci.nsIConsoleService).logStringMessage(e);
}