/*
 * This file was generated by the MozButton SDK,
 * which is part of the Toolbar Buttons project.
 * You should not edit this file, but rather download
 * the project source and rerun the builder.
 */

const Cc = Components.classes;
const Ci = Components.interfaces;
const Cu = Components.utils;

var EXPORTED_SYMBOLS = ["loadButtons", "unloadButtons", "setupButtons", "shutdownButtons"];

try {
	Cu.import("resource:///modules/CustomizableUI.jsm");
} catch(e) {
	Cu.import("chrome://toolbar-buttons/content/customizable.jsm");
}

Cu.import('resource://gre/modules/Services.jsm');
Cu.import("resource://services-common/stringbundle.js");



var gShutDownFunctions = [];

var toolbar_buttons = {
	interfaces: {},
	// the important global objects used by the extension
	toolbar_button_loader: function(parent, child) {
		var object_name;
		for(object_name in child){
			if(object_name == 'interfaces') {
				toolbar_buttons.toolbar_button_loader(parent.interfaces, child.interfaces);
			} else {
				parent[object_name] = child[object_name];
			}
		}
	},
	registerCleanUpFunction: function(func) {
		gShutDownFunctions.push(func);
	}

};
var loader = Cc["@mozilla.org/moz/jssubscript-loader;1"].getService(Ci.mozIJSSubScriptLoader);
var gScope = this;
// the number at the end forces a reload of the properties file, since sometimes it it catched when we don't want
var buttonStrings = new StringBundle("chrome://toolbar-buttons/locale/button_labels.properties?time=" + Date.now().toString());

function setupButtons() {
	
		CustomizableUI.createWidget({
		id: 'reset',
		type: 'custom',
		label: buttonStrings.get('reset.label'),
		tooltiptext: buttonStrings.get('reset.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'reset';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('reset.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('reset.tooltip'));
			toolbarbutton_0.addEventListener('command', function(event) {
				var window = event.target.ownerDocument.defaultView;
			window.goDoCommand('cmd_fullZoomReset');
			}, false);
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("msgHeaderView-button");
			return toolbarbutton_0;
		},
		toolbox: 'header-view-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'realNextMessage',
		type: 'custom',
		label: buttonStrings.get('realNextMessage.label'),
		tooltiptext: buttonStrings.get('realNextMessage.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'realNextMessage';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('realNextMessage.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('realNextMessage.tooltip'));
			toolbarbutton_0.addEventListener('command', function(event) {
				toolbar_buttons.realNextMessage(event);
			}, false);
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("msgHeaderView-button");
			return toolbarbutton_0;
		},
		toolbox: 'header-view-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'reply-sender',
		type: 'custom',
		label: buttonStrings.get('reply-sender.label'),
		tooltiptext: buttonStrings.get('reply-sender.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'reply-sender';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('reply-sender.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('reply-sender.tooltip'));
			toolbarbutton_0.addEventListener('command', function(event) {
				var window = event.target.ownerDocument.defaultView;
			window.goDoCommand('cmd_replySender');
			}, false);
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("msgHeaderView-button");
			return toolbarbutton_0;
		},
		toolbox: 'header-view-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'realPreviousMessage',
		type: 'custom',
		label: buttonStrings.get('realPreviousMessage.label'),
		tooltiptext: buttonStrings.get('realPreviousMessage.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'realPreviousMessage';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('realPreviousMessage.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('realPreviousMessage.tooltip'));
			toolbarbutton_0.addEventListener('command', function(event) {
				toolbar_buttons.realPreviousMessage(event);
			}, false);
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("msgHeaderView-button");
			return toolbarbutton_0;
		},
		toolbox: 'header-view-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'reduce',
		type: 'custom',
		label: buttonStrings.get('reduce.label'),
		tooltiptext: buttonStrings.get('reduce.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'reduce';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('reduce.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('reduce.tooltip'));
			toolbarbutton_0.addEventListener('command', function(event) {
				var window = event.target.ownerDocument.defaultView;
			window.goDoCommand('cmd_fullZoomReduce')
			}, false);
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("msgHeaderView-button");
			return toolbarbutton_0;
		},
		toolbox: 'header-view-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'enlarge',
		type: 'custom',
		label: buttonStrings.get('enlarge.label'),
		tooltiptext: buttonStrings.get('enlarge.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'enlarge';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('enlarge.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('enlarge.tooltip'));
			toolbarbutton_0.addEventListener('command', function(event) {
				var window = event.target.ownerDocument.defaultView;
			window.goDoCommand('cmd_fullZoomEnlarge');
			}, false);
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("msgHeaderView-button");
			return toolbarbutton_0;
		},
		toolbox: 'header-view-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'html-mode',
		type: 'custom',
		label: buttonStrings.get('html-mode.label'),
		tooltiptext: buttonStrings.get('html-mode.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'html-mode';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('html-mode.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('html-mode.tooltip'));
			toolbarbutton_0.addEventListener('command', function(event) {
				toolbar_buttons.toggleHtmlMode(event);
			}, false);
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("msgHeaderView-button");
			toolbarbutton_0.setAttribute("persist", "html");
			return toolbarbutton_0;
		},
		toolbox: 'header-view-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'forward-as-inline',
		type: 'custom',
		label: buttonStrings.get('forward-as-inline.label'),
		tooltiptext: buttonStrings.get('forward-as-inline.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'forward-as-inline';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('forward-as-inline.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('forward-as-inline.tooltip'));
			toolbarbutton_0.addEventListener('command', function(event) {
				var window = event.target.ownerDocument.defaultView;
			window.MsgForwardAsInline(event);
			}, false);
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("msgHeaderView-button");
			return toolbarbutton_0;
		},
		toolbox: 'header-view-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'forward-as-attachment',
		type: 'custom',
		label: buttonStrings.get('forward-as-attachment.label'),
		tooltiptext: buttonStrings.get('forward-as-attachment.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'forward-as-attachment';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('forward-as-attachment.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('forward-as-attachment.tooltip'));
			toolbarbutton_0.addEventListener('command', function(event) {
				var window = event.target.ownerDocument.defaultView;
			window.MsgForwardAsAttachment(event);
			}, false);
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("msgHeaderView-button");
			return toolbarbutton_0;
		},
		toolbox: 'header-view-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'toggle-read',
		type: 'custom',
		label: buttonStrings.get('toggle-read.label'),
		tooltiptext: buttonStrings.get('toggle-read.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'toggle-read';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('toggle-read.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('toggle-read.tooltip'));
			toolbarbutton_0.addEventListener('command', function(event) {
				var window = event.target.ownerDocument.defaultView;
			window.goDoCommand('cmd_toggleRead');
			}, false);
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("msgHeaderView-button");
			return toolbarbutton_0;
		},
		toolbox: 'header-view-toolbox'
	});

	CustomizableUI.createWidget({
		id: 'edit-as-new',
		type: 'custom',
		label: buttonStrings.get('edit-as-new.label'),
		tooltiptext: buttonStrings.get('edit-as-new.tooltip'),
		onBuild: function (document) {
			var window = document.defaultView;
			var toolbarbutton_0 = document.createElement('toolbarbutton');
			toolbarbutton_0.id = 'edit-as-new';
			toolbarbutton_0.setAttribute('label', buttonStrings.get('edit-as-new.label'));
			toolbarbutton_0.setAttribute('tooltiptext', buttonStrings.get('edit-as-new.tooltip'));
			toolbarbutton_0.setAttribute("command", "cmd_editAsNew");
			toolbarbutton_0.classList.add("toolbarbutton-1");
			toolbarbutton_0.classList.add("msgHeaderView-button");
			return toolbarbutton_0;
		},
		toolbox: 'header-view-toolbox'
	});
}

function loadButtons(window) {
	var document = window.document;
	var toolbox = document.getElementById('header-view-toolbox');
	if(!toolbox) {
		return;
	}
	
	registerToolbars(window, document, []);
	
	
	
}

function createToolbar(doc, toolbox, attributes, name) {
	var special = ["id", "class", "defaultset", "currentset"];
	var toolbar = doc.createElement('toolbar');
	for(var attr in attributes) {
		if(special.indexOf(attr) == -1) {
			toolbar.setAttribute(attr, attributes[attr]);
		}
	}
	toolbar.setAttribute('toolbarname', name);
	if(attributes.id) {
		toolbar.id = attributes.id;
	}
	if(attributes.class) {
		toolbar.className = attributes.class;
	}
	doc.getElementById(toolbox).appendChild(toolbar);
	// put after appending to stop Thunderbird/SeaMonkey loading the buttons
	// which messes with our CustomizableUI
	if(attributes.defaultset) {
		toolbar.setAttribute('defaultset', attributes['defaultset']);
	}
	if(attributes.currentset) {
		toolbar.setAttribute('currentset', attributes['currentset']);
	}
}

var gButtonIds = ["reset", "realNextMessage", "reply-sender", "realPreviousMessage", "reduce", "enlarge", "html-mode", "forward-as-inline", "forward-as-attachment", "toggle-read", "edit-as-new"];

function unloadButtons(window) {
	var document = window.document;
	var toolbarIds = [];
	var uiIds = [];

	for(var t = 0; t < toolbarIds.length; t++) {
		var toolbar = document.getElementById(toolbarIds[t]);
		if(toolbar) {
			CustomizableUI.unregisterArea(toolbarIds[t], false);
			toolbar.parentNode.removeChild(toolbar);
		}
	}
	for(var i = 0; i < gButtonIds.length; i++) {
		var buttonId = gButtonIds[i];
		var key = document.getElementById(buttonId + '-key');
		if(key) {
			key.parentNode.removeChild(key);
		}
		var menuitem = document.getElementById(buttonId + '-menu-item');
		if(menuitem) {
			menuitem.parentNode.removeChild(menuitem);
		}
	}
	var menu = document.getElementById('toolbar-buttons-menu');
	if(menu && !menu.firstChild.firstChild) {
		menu.parentNode.removeChild(menu);
	}
	for(var i = 0; i < uiIds.length; i++) {
		var node = document.getElementById(uiIds[i]);
		while(node) {
			node.parentNode.removeChild(node);
			node = document.getElementById(uiIds[i]);
		}
	}
	for(var i = 0; i < gShutDownFunctions.length; i++) {
		try {
			gShutDownFunctions[i]();
		} catch(e) {}
	}
}

function shutdownButtons() {
	log(gButtonIds);
	for(var i = 0; i < gButtonIds.length; i++) {
		CustomizableUI.destroyWidget(gButtonIds[i]);
	}
}

function registerToolbars(window, document, toolbar_ids) {
	for(var i in toolbar_ids) {
		observeToolbar(window, document, toolbar_ids[i]);
		CustomizableUI.registerArea(toolbar_ids[i], {
			type: CustomizableUI.TYPE_TOOLBAR,
			defaultPlacements: [],
			defaultCollapsed: false
		}, true);
	}
}

function observeToolbar(window, document, toolbar_id) {
	var prefs = Cc['@mozilla.org/preferences-service;1'].getService(Ci.nsIPrefService)
			.getBranch("extension.tbutton." + 'toolbar_status.' + toolbar_id + '.');
	var toolbar = document.getElementById(toolbar_id);
	var observer = function(mutations) {
		mutations.forEach(function(mutation) {
			if(mutation.attributeName && (CustomizableUI.shim || mutation.attributeName != 'currentset')) {
				prefs.setCharPref(mutation.attributeName, toolbar.getAttribute(mutation.attributeName));
			}
		});
	}
	var mutationObserver = new window.MutationObserver(observer);
	var attrList = prefs.getChildList('', {});
	for(var i in attrList) {
		toolbar.setAttribute(attrList[i], prefs.getCharPref(attrList[i]));
	}
	mutationObserver.observe(toolbar, { attributes: true, subtree: false });
}

function log(e) {
	Cc["@mozilla.org/consoleservice;1"].getService(Ci.nsIConsoleService).logStringMessage(e);
}